// **********************************************************************
//
// Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.6.3
//
// <auto-generated>
//
// Generated from file `FileParser.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef ICE_GRID_API_EXPORTS
#   define ICE_GRID_API_EXPORTS
#endif
#include <IceGrid/FileParser.h>
#include <IceUtil/PushDisableWarnings.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/BasicStream.h>
#include <Ice/SlicedData.h>
#include <Ice/SliceChecksums.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/PopDisableWarnings.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 306
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 3
#       error Ice patch level mismatch!
#   endif
#endif

namespace
{

const ::std::string __IceGrid__FileParser__parse_name = "parse";

}

namespace
{

const ::IceInternal::DefaultUserExceptionFactoryInit< ::IceGrid::ParseException> __IceGrid__ParseException_init("::IceGrid::ParseException");

}

IceGrid::ParseException::ParseException(const ::std::string& __ice_reason) :
    ::Ice::UserException(),
    reason(__ice_reason)
{
}

IceGrid::ParseException::~ParseException() throw()
{
}

::std::string
IceGrid::ParseException::ice_name() const
{
    return "IceGrid::ParseException";
}

IceGrid::ParseException*
IceGrid::ParseException::ice_clone() const
{
    return new ParseException(*this);
}

void
IceGrid::ParseException::ice_throw() const
{
    throw *this;
}

void
IceGrid::ParseException::__writeImpl(::IceInternal::BasicStream* __os) const
{
    __os->startWriteSlice("::IceGrid::ParseException", -1, true);
    __os->write(reason);
    __os->endWriteSlice();
}

void
IceGrid::ParseException::__readImpl(::IceInternal::BasicStream* __is)
{
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

namespace Ice
{
}
#ifdef __SUNPRO_CC
class ICE_GRID_API IceProxy::IceGrid::FileParser;
#endif
ICE_GRID_API ::IceProxy::Ice::Object* ::IceProxy::IceGrid::upCast(::IceProxy::IceGrid::FileParser* p) { return p; }

void
::IceProxy::IceGrid::__read(::IceInternal::BasicStream* __is, ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::FileParser>& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::IceGrid::FileParser;
        v->__copyFrom(proxy);
    }
}

::IceGrid::ApplicationDescriptor
IceProxy::IceGrid::FileParser::parse(const ::std::string& __p_xmlFile, const ::IceGrid::AdminPrx& __p_adminProxy, const ::Ice::Context* __ctx)
{
    __checkTwowayOnly(__IceGrid__FileParser__parse_name);
    ::IceInternal::Outgoing __og(this, __IceGrid__FileParser__parse_name, ::Ice::Idempotent, __ctx);
    try
    {
        ::IceInternal::BasicStream* __os = __og.startWriteParams(::Ice::DefaultFormat);
        __os->write(__p_xmlFile);
        __os->write(__p_adminProxy);
        __og.endWriteParams();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    if(!__og.invoke())
    {
        try
        {
            __og.throwUserException();
        }
        catch(const ::IceGrid::ParseException&)
        {
            throw;
        }
        catch(const ::Ice::UserException& __ex)
        {
            ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
            throw __uue;
        }
    }
    ::IceGrid::ApplicationDescriptor __ret;
    ::IceInternal::BasicStream* __is = __og.startReadParams();
    __is->read(__ret);
    __is->readPendingObjects();
    __og.endReadParams();
    return __ret;
}

::Ice::AsyncResultPtr
IceProxy::IceGrid::FileParser::begin_parse(const ::std::string& __p_xmlFile, const ::IceGrid::AdminPrx& __p_adminProxy, const ::Ice::Context* __ctx, const ::IceInternal::CallbackBasePtr& __del, const ::Ice::LocalObjectPtr& __cookie)
{
    __checkAsyncTwowayOnly(__IceGrid__FileParser__parse_name);
    ::IceInternal::OutgoingAsyncPtr __result = new ::IceInternal::OutgoingAsync(this, __IceGrid__FileParser__parse_name, __del, __cookie);
    try
    {
        __result->prepare(__IceGrid__FileParser__parse_name, ::Ice::Idempotent, __ctx);
        ::IceInternal::BasicStream* __os = __result->startWriteParams(::Ice::DefaultFormat);
        __os->write(__p_xmlFile);
        __os->write(__p_adminProxy);
        __result->endWriteParams();
        __result->invoke();
    }
    catch(const ::Ice::Exception& __ex)
    {
        __result->abort(__ex);
    }
    return __result;
}

#ifdef ICE_CPP11

::Ice::AsyncResultPtr
IceProxy::IceGrid::FileParser::__begin_parse(const ::std::string& __p_xmlFile, const ::IceGrid::AdminPrx& __p_adminProxy, const ::Ice::Context* __ctx, const ::IceInternal::Function<void (const ::IceGrid::ApplicationDescriptor&)>& __response, const ::IceInternal::Function<void (const ::Ice::Exception&)>& __exception, const ::IceInternal::Function<void (bool)>& __sent)
{
    class Cpp11CB : public ::IceInternal::Cpp11FnCallbackNC
    {
    public:

        Cpp11CB(const ::std::function<void (const ::IceGrid::ApplicationDescriptor&)>& responseFunc, const ::std::function<void (const ::Ice::Exception&)>& exceptionFunc, const ::std::function<void (bool)>& sentFunc) :
            ::IceInternal::Cpp11FnCallbackNC(exceptionFunc, sentFunc),
            _response(responseFunc)
        {
            CallbackBase::checkCallback(true, responseFunc || exceptionFunc != nullptr);
        }

        virtual void completed(const ::Ice::AsyncResultPtr& __result) const
        {
            ::IceGrid::FileParserPrx __proxy = ::IceGrid::FileParserPrx::uncheckedCast(__result->getProxy());
            ::IceGrid::ApplicationDescriptor __ret;
            try
            {
                __ret = __proxy->end_parse(__result);
            }
            catch(const ::Ice::Exception& ex)
            {
                Cpp11FnCallbackNC::exception(__result, ex);
                return;
            }
            if(_response != nullptr)
            {
                _response(__ret);
            }
        }
    
    private:
        
        ::std::function<void (const ::IceGrid::ApplicationDescriptor&)> _response;
    };
    return begin_parse(__p_xmlFile, __p_adminProxy, __ctx, new Cpp11CB(__response, __exception, __sent));
}
#endif

::IceGrid::ApplicationDescriptor
IceProxy::IceGrid::FileParser::end_parse(const ::Ice::AsyncResultPtr& __result)
{
    ::Ice::AsyncResult::__check(__result, this, __IceGrid__FileParser__parse_name);
    ::IceGrid::ApplicationDescriptor __ret;
    if(!__result->__wait())
    {
        try
        {
            __result->__throwUserException();
        }
        catch(const ::IceGrid::ParseException&)
        {
            throw;
        }
        catch(const ::Ice::UserException& __ex)
        {
            throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
        }
    }
    ::IceInternal::BasicStream* __is = __result->__startReadParams();
    __is->read(__ret);
    __is->readPendingObjects();
    __result->__endReadParams();
    return __ret;
}

const ::std::string&
IceProxy::IceGrid::FileParser::ice_staticId()
{
    return ::IceGrid::FileParser::ice_staticId();
}

::IceProxy::Ice::Object*
IceProxy::IceGrid::FileParser::__newInstance() const
{
    return new FileParser;
}

ICE_GRID_API ::Ice::Object* IceGrid::upCast(::IceGrid::FileParser* p) { return p; }

namespace
{
const ::std::string __IceGrid__FileParser_ids[2] =
{
    "::Ice::Object",
    "::IceGrid::FileParser"
};

}

bool
IceGrid::FileParser::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__IceGrid__FileParser_ids, __IceGrid__FileParser_ids + 2, _s);
}

::std::vector< ::std::string>
IceGrid::FileParser::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__IceGrid__FileParser_ids[0], &__IceGrid__FileParser_ids[2]);
}

const ::std::string&
IceGrid::FileParser::ice_id(const ::Ice::Current&) const
{
    return __IceGrid__FileParser_ids[1];
}

const ::std::string&
IceGrid::FileParser::ice_staticId()
{
#ifdef ICE_HAS_THREAD_SAFE_LOCAL_STATIC
    static const ::std::string typeId = "::IceGrid::FileParser";
    return typeId;
#else
    return __IceGrid__FileParser_ids[1];
#endif
}

::Ice::DispatchStatus
IceGrid::FileParser::___parse(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.startReadParams();
    ::std::string __p_xmlFile;
    ::IceGrid::AdminPrx __p_adminProxy;
    __is->read(__p_xmlFile);
    __is->read(__p_adminProxy);
    __inS.endReadParams();
    try
    {
        ::IceGrid::ApplicationDescriptor __ret = parse(__p_xmlFile, __p_adminProxy, __current);
        ::IceInternal::BasicStream* __os = __inS.__startWriteParams(::Ice::DefaultFormat);
        __os->write(__ret);
        __os->writePendingObjects();
        __inS.__endWriteParams(true);
        return ::Ice::DispatchOK;
    }
    catch(const ::IceGrid::ParseException& __ex)
    {
        __inS.__writeUserException(__ex, ::Ice::DefaultFormat);
    }
    return ::Ice::DispatchUserException;
}

namespace
{
const ::std::string __IceGrid__FileParser_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "parse"
};

}

::Ice::DispatchStatus
IceGrid::FileParser::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< const ::std::string*, const ::std::string*> r = ::std::equal_range(__IceGrid__FileParser_all, __IceGrid__FileParser_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __IceGrid__FileParser_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___parse(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
IceGrid::FileParser::__writeImpl(::IceInternal::BasicStream* __os) const
{
    __os->startWriteSlice(ice_staticId(), -1, true);
    __os->endWriteSlice();
}

void
IceGrid::FileParser::__readImpl(::IceInternal::BasicStream* __is)
{
    __is->startReadSlice();
    __is->endReadSlice();
}

void ICE_GRID_API 
IceGrid::__patch(FileParserPtr& handle, const ::Ice::ObjectPtr& v)
{
    handle = ::IceGrid::FileParserPtr::dynamicCast(v);
    if(v && !handle)
    {
        IceInternal::Ex::throwUOE(::IceGrid::FileParser::ice_staticId(), v);
    }
}

namespace
{

const char* __sliceChecksums[] =
{
    "::IceGrid::FileParser", "b847ccf3e3db7cbba649ec7cc464faf",
    "::IceGrid::ParseException", "dec9aacba8b3ba76afc5de1cc3489598",
    0
};
const IceInternal::SliceChecksumInit __sliceChecksumInit(__sliceChecksums);

}
